import{S as dn,i as un,s as cn,e as r,k as u,w as D,t as o,M as fn,c as a,d as t,m as c,a as i,x as U,h as l,b as f,G as s,g as p,y as k,q as C,o as G,B as T,v as mn}from"../../chunks/vendor-hf-doc-builder.js";import{T as js}from"../../chunks/Tip-hf-doc-builder.js";import{D as hn}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Gt}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ye}from"../../chunks/IconCopyLink-hf-doc-builder.js";function yn(W){let d,b,m,h,E,_,$,w,j;return{c(){d=r("p"),b=o("\u{1F4A1} We strongly recommend reading PyTorch\u2019s "),m=r("a"),h=o("statement about reproducibility"),E=o(":"),_=u(),$=r("blockquote"),w=r("p"),j=o("Completely reproducible results are not guaranteed across PyTorch releases, individual commits, or different platforms. Furthermore, results may not be reproducible between CPU and GPU executions, even when using identical seeds."),this.h()},l(g){d=a(g,"P",{});var y=i(d);b=l(y,"\u{1F4A1} We strongly recommend reading PyTorch\u2019s "),m=a(y,"A",{href:!0,rel:!0});var I=i(m);h=l(I,"statement about reproducibility"),I.forEach(t),E=l(y,":"),y.forEach(t),_=c(g),$=a(g,"BLOCKQUOTE",{});var v=i($);w=a(v,"P",{});var A=i(w);j=l(A,"Completely reproducible results are not guaranteed across PyTorch releases, individual commits, or different platforms. Furthermore, results may not be reproducible between CPU and GPU executions, even when using identical seeds."),A.forEach(t),v.forEach(t),this.h()},h(){f(m,"href","https://pytorch.org/docs/stable/notes/randomness.html"),f(m,"rel","nofollow")},m(g,y){p(g,d,y),s(d,b),s(d,m),s(m,h),s(d,E),p(g,_,y),p(g,$,y),s($,w),s(w,j)},d(g){g&&t(d),g&&t(_),g&&t($)}}}function gn(W){let d,b,m,h,E,_,$,w,j,g,y;return{c(){d=r("p"),b=o("\u{1F4A1} It might be a bit unintuitive at first to pass "),m=r("code"),h=o("Generator"),E=o(` objects to the pipeline instead of
just integer values representing the seed, but this is the recommended design when dealing with
probabilistic models in PyTorch as `),_=r("code"),$=o("Generator"),w=o("\u2019s are "),j=r("em"),g=o("random states"),y=o(` that can be
passed to multiple pipelines in a sequence.`)},l(I){d=a(I,"P",{});var v=i(d);b=l(v,"\u{1F4A1} It might be a bit unintuitive at first to pass "),m=a(v,"CODE",{});var A=i(m);h=l(A,"Generator"),A.forEach(t),E=l(v,` objects to the pipeline instead of
just integer values representing the seed, but this is the recommended design when dealing with
probabilistic models in PyTorch as `),_=a(v,"CODE",{});var fe=i(_);$=l(fe,"Generator"),fe.forEach(t),w=l(v,"\u2019s are "),j=a(v,"EM",{});var ee=i(j);g=l(ee,"random states"),ee.forEach(t),y=l(v,` that can be
passed to multiple pipelines in a sequence.`),v.forEach(t)},m(I,v){p(I,d,v),s(d,b),s(d,m),s(m,h),s(d,E),s(d,_),s(_,$),s(d,w),s(d,j),s(j,g),s(d,y)},d(I){I&&t(d)}}}function vn(W){let d,b;return{c(){d=r("p"),b=o(`\u{1F4A1} If reproducibility is important, we recommend always passing a CPU generator.
The performance loss is often neglectable, and you\u2019ll generate much more similar
values than if the pipeline had been run on a GPU.`)},l(m){d=a(m,"P",{});var h=i(d);b=l(h,`\u{1F4A1} If reproducibility is important, we recommend always passing a CPU generator.
The performance loss is often neglectable, and you\u2019ll generate much more similar
values than if the pipeline had been run on a GPU.`),h.forEach(t)},m(m,h){p(m,d,h),s(d,b)},d(m){m&&t(d)}}}function _n(W){let d,b,m,h,E,_,$,w,j,g,y,I,v,A,fe,ee,me,Tt,Je,L,Ke,M,H,Ue,te,It,ke,qt,Qe,he,xt,Ve,B,At,ye,Mt,Nt,Xe,se,Ze,ge,Ot,et,z,St,ne,Ce,Rt,Ft,tt,ve,Wt,st,N,Y,Ge,re,Lt,Te,Ht,nt,J,Bt,ae,Ie,zt,Yt,rt,ie,at,q,Jt,qe,Kt,Qt,xe,Vt,Xt,it,_e,Zt,ot,K,lt,O,Q,Ae,oe,es,Me,ts,pt,be,ss,dt,le,ut,we,ns,ct,P,rs,$e,Ne,as,is,Oe,os,ls,Se,ps,ds,Re,us,cs,ft,Pe,fs,mt,pe,ht,V,yt,X,ms,Ee,hs,ys,gt,S,Z,Fe,de,gs,We,vs,vt,R,ue,_s,F,bs,Le,ws,$s,He,Ps,Es,_t;return _=new Ye({}),L=new js({props:{$$slots:{default:[yn]},$$scope:{ctx:W}}}),te=new Ye({}),se=new Gt({props:{code:`from diffusers import DDIMPipeline
import numpy as np

model_id = "google/ddpm-cifar10-32"

# load model and scheduler
ddim = DDIMPipeline.from_pretrained(model_id)

# run pipeline for just two steps and return numpy tensor
image = ddim(num_inference_steps=2, output_type="np").images
print(np.abs(image).sum())`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMPipeline
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

model_id = <span class="hljs-string">&quot;google/ddpm-cifar10-32&quot;</span>

<span class="hljs-comment"># load model and scheduler</span>
ddim = DDIMPipeline.from_pretrained(model_id)

<span class="hljs-comment"># run pipeline for just two steps and return numpy tensor</span>
image = ddim(num_inference_steps=<span class="hljs-number">2</span>, output_type=<span class="hljs-string">&quot;np&quot;</span>).images
<span class="hljs-built_in">print</span>(np.<span class="hljs-built_in">abs</span>(image).<span class="hljs-built_in">sum</span>())`}}),re=new Ye({}),ie=new Gt({props:{code:`import torch
from diffusers import DDIMPipeline
import numpy as np

model_id = "google/ddpm-cifar10-32"

# load model and scheduler
ddim = DDIMPipeline.from_pretrained(model_id)

# create a generator for reproducibility
generator = torch.Generator(device="cpu").manual_seed(0)

# run pipeline for just two steps and return numpy tensor
image = ddim(num_inference_steps=2, output_type="np", generator=generator).images
print(np.abs(image).sum())`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMPipeline
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

model_id = <span class="hljs-string">&quot;google/ddpm-cifar10-32&quot;</span>

<span class="hljs-comment"># load model and scheduler</span>
ddim = DDIMPipeline.from_pretrained(model_id)

<span class="hljs-comment"># create a generator for reproducibility</span>
generator = torch.Generator(device=<span class="hljs-string">&quot;cpu&quot;</span>).manual_seed(<span class="hljs-number">0</span>)

<span class="hljs-comment"># run pipeline for just two steps and return numpy tensor</span>
image = ddim(num_inference_steps=<span class="hljs-number">2</span>, output_type=<span class="hljs-string">&quot;np&quot;</span>, generator=generator).images
<span class="hljs-built_in">print</span>(np.<span class="hljs-built_in">abs</span>(image).<span class="hljs-built_in">sum</span>())`}}),K=new js({props:{$$slots:{default:[gn]},$$scope:{ctx:W}}}),oe=new Ye({}),le=new Gt({props:{code:`import torch
from diffusers import DDIMPipeline
import numpy as np

model_id = "google/ddpm-cifar10-32"

# load model and scheduler
ddim = DDIMPipeline.from_pretrained(model_id)
ddim.to("cuda")

# create a generator for reproducibility
generator = torch.Generator(device="cuda").manual_seed(0)

# run pipeline for just two steps and return numpy tensor
image = ddim(num_inference_steps=2, output_type="np", generator=generator).images
print(np.abs(image).sum())`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMPipeline
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

model_id = <span class="hljs-string">&quot;google/ddpm-cifar10-32&quot;</span>

<span class="hljs-comment"># load model and scheduler</span>
ddim = DDIMPipeline.from_pretrained(model_id)
ddim.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># create a generator for reproducibility</span>
generator = torch.Generator(device=<span class="hljs-string">&quot;cuda&quot;</span>).manual_seed(<span class="hljs-number">0</span>)

<span class="hljs-comment"># run pipeline for just two steps and return numpy tensor</span>
image = ddim(num_inference_steps=<span class="hljs-number">2</span>, output_type=<span class="hljs-string">&quot;np&quot;</span>, generator=generator).images
<span class="hljs-built_in">print</span>(np.<span class="hljs-built_in">abs</span>(image).<span class="hljs-built_in">sum</span>())`}}),pe=new Gt({props:{code:`import torch
from diffusers import DDIMPipeline
import numpy as np

model_id = "google/ddpm-cifar10-32"

# load model and scheduler
ddim = DDIMPipeline.from_pretrained(model_id)
ddim.to("cuda")

# create a generator for reproducibility; notice you don't place it on the GPU!
generator = torch.manual_seed(0)

# run pipeline for just two steps and return numpy tensor
image = ddim(num_inference_steps=2, output_type="np", generator=generator).images
print(np.abs(image).sum())`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DDIMPipeline
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

model_id = <span class="hljs-string">&quot;google/ddpm-cifar10-32&quot;</span>

<span class="hljs-comment"># load model and scheduler</span>
ddim = DDIMPipeline.from_pretrained(model_id)
ddim.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># create a generator for reproducibility; notice you don&#x27;t place it on the GPU!</span>
generator = torch.manual_seed(<span class="hljs-number">0</span>)

<span class="hljs-comment"># run pipeline for just two steps and return numpy tensor</span>
image = ddim(num_inference_steps=<span class="hljs-number">2</span>, output_type=<span class="hljs-string">&quot;np&quot;</span>, generator=generator).images
<span class="hljs-built_in">print</span>(np.<span class="hljs-built_in">abs</span>(image).<span class="hljs-built_in">sum</span>())`}}),V=new js({props:{$$slots:{default:[vn]},$$scope:{ctx:W}}}),de=new Ye({}),ue=new hn({props:{name:"diffusers.utils.randn_tensor",anchor:"diffusers.utils.randn_tensor",parameters:[{name:"shape",val:": typing.Union[typing.Tuple, typing.List]"},{name:"generator",val:": typing.Union[typing.List[ForwardRef('torch.Generator')], ForwardRef('torch.Generator'), NoneType] = None"},{name:"device",val:": typing.Optional[ForwardRef('torch.device')] = None"},{name:"dtype",val:": typing.Optional[ForwardRef('torch.dtype')] = None"},{name:"layout",val:": typing.Optional[ForwardRef('torch.layout')] = None"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/utils/torch_utils.py#L29"}}),{c(){d=r("meta"),b=u(),m=r("h1"),h=r("a"),E=r("span"),D(_.$$.fragment),$=u(),w=r("span"),j=o("Create reproducible pipelines"),g=u(),y=r("p"),I=o("Reproducibility is important for testing, replicating results, and can even be used to "),v=r("a"),A=o("improve image quality"),fe=o(". However, the randomness in diffusion models is a desired property because it allows the pipeline to generate different images every time it is run. While you can\u2019t expect to get the exact same results across platforms, you can expect results to be reproducible across releases and platforms within a certain tolerance range. Even then, tolerance varies depending on the diffusion pipeline and checkpoint."),ee=u(),me=r("p"),Tt=o("This is why it\u2019s important to understand how to control sources of randomness in diffusion models."),Je=u(),D(L.$$.fragment),Ke=u(),M=r("h2"),H=r("a"),Ue=r("span"),D(te.$$.fragment),It=u(),ke=r("span"),qt=o("Inference"),Qe=u(),he=r("p"),xt=o(`During inference, pipelines rely heavily on random sampling operations which include creating the
Gaussian noise tensors to denoise and adding noise to the scheduling step.`),Ve=u(),B=r("p"),At=o("Take a look at the tensor values in the "),ye=r("a"),Mt=o("DDIMPipeline"),Nt=o(" after two inference steps:"),Xe=u(),D(se.$$.fragment),Ze=u(),ge=r("p"),Ot=o("Running the code above prints one value, but if you run it again you get a different value. What is going on here?"),et=u(),z=r("p"),St=o("Every time the pipeline is run, "),ne=r("a"),Ce=r("code"),Rt=o("torch.randn"),Ft=o(" uses a different random seed to create Gaussian noise which is denoised stepwise. This leads to a different result each time it is run, which is great for diffusion pipelines since it generates a different random image each time."),tt=u(),ve=r("p"),Wt=o("But if you need to reliably generate the same image, that\u2019ll depend on whether you\u2019re running the pipeline on a CPU or GPU."),st=u(),N=r("h3"),Y=r("a"),Ge=r("span"),D(re.$$.fragment),Lt=u(),Te=r("span"),Ht=o("CPU"),nt=u(),J=r("p"),Bt=o("To generate reproducible results on a CPU, you\u2019ll need to use a PyTorch "),ae=r("a"),Ie=r("code"),zt=o("Generator"),Yt=o(" and set a seed:"),rt=u(),D(ie.$$.fragment),at=u(),q=r("p"),Jt=o("Now when you run the code above, it always prints a value of "),qe=r("code"),Kt=o("1491.1711"),Qt=o(" no matter what because the "),xe=r("code"),Vt=o("Generator"),Xt=o(" object with the seed is passed to all the random functions of the pipeline."),it=u(),_e=r("p"),Zt=o("If you run this code example on your specific hardware and PyTorch version, you should get a similar, if not the same, result."),ot=u(),D(K.$$.fragment),lt=u(),O=r("h3"),Q=r("a"),Ae=r("span"),D(oe.$$.fragment),es=u(),Me=r("span"),ts=o("GPU"),pt=u(),be=r("p"),ss=o("Writing a reproducible pipeline on a GPU is a bit trickier, and full reproducibility across different hardware is not guaranteed because matrix multiplication - which diffusion pipelines require a lot of - is less deterministic on a GPU than a CPU. For example, if you run the same code example above on a GPU:"),dt=u(),D(le.$$.fragment),ut=u(),we=r("p"),ns=o("The result is not the same even though you\u2019re using an identical seed because the GPU uses a different random number generator than the CPU."),ct=u(),P=r("p"),rs=o("To circumvent this problem, \u{1F9E8} Diffusers has a "),$e=r("a"),Ne=r("code"),as=o("randn_tensor"),is=o(" function for creating random noise on the CPU, and then moving the tensor to a GPU if necessary. The "),Oe=r("code"),os=o("randn_tensor"),ls=o(" function is used everywhere inside the pipeline, allowing the user to "),Se=r("strong"),ps=o("always"),ds=o(" pass a CPU "),Re=r("code"),us=o("Generator"),cs=o(" even if the pipeline is run on a GPU."),ft=u(),Pe=r("p"),fs=o("You\u2019ll see the results are much closer now!"),mt=u(),D(pe.$$.fragment),ht=u(),D(V.$$.fragment),yt=u(),X=r("p"),ms=o("Finally, for more complex pipelines such as "),Ee=r("a"),hs=o("UnCLIPPipeline"),ys=o(`, these are often extremely
susceptible to precision error propagation. Don\u2019t expect similar results across
different GPU hardware or PyTorch versions. In this case, you\u2019ll need to run
exactly the same hardware and PyTorch version for full reproducibility.`),gt=u(),S=r("h2"),Z=r("a"),Fe=r("span"),D(de.$$.fragment),gs=u(),We=r("span"),vs=o("randn_tensor"),vt=u(),R=r("div"),D(ue.$$.fragment),_s=u(),F=r("p"),bs=o("This is a helper function that allows to create random tensors on the desired "),Le=r("code"),ws=o("device"),$s=o(" with the desired "),He=r("code"),Ps=o("dtype"),Es=o(`. When
passing a list of generators one can seed each batched size individually. If CPU generators are passed the tensor
will always be created on CPU.`),this.h()},l(e){const n=fn('[data-svelte="svelte-1phssyn"]',document.head);d=a(n,"META",{name:!0,content:!0}),n.forEach(t),b=c(e),m=a(e,"H1",{class:!0});var ce=i(m);h=a(ce,"A",{id:!0,class:!0,href:!0});var Be=i(h);E=a(Be,"SPAN",{});var ze=i(E);U(_.$$.fragment,ze),ze.forEach(t),Be.forEach(t),$=c(ce),w=a(ce,"SPAN",{});var Ds=i(w);j=l(Ds,"Create reproducible pipelines"),Ds.forEach(t),ce.forEach(t),g=c(e),y=a(e,"P",{});var bt=i(y);I=l(bt,"Reproducibility is important for testing, replicating results, and can even be used to "),v=a(bt,"A",{href:!0});var Us=i(v);A=l(Us,"improve image quality"),Us.forEach(t),fe=l(bt,". However, the randomness in diffusion models is a desired property because it allows the pipeline to generate different images every time it is run. While you can\u2019t expect to get the exact same results across platforms, you can expect results to be reproducible across releases and platforms within a certain tolerance range. Even then, tolerance varies depending on the diffusion pipeline and checkpoint."),bt.forEach(t),ee=c(e),me=a(e,"P",{});var ks=i(me);Tt=l(ks,"This is why it\u2019s important to understand how to control sources of randomness in diffusion models."),ks.forEach(t),Je=c(e),U(L.$$.fragment,e),Ke=c(e),M=a(e,"H2",{class:!0});var wt=i(M);H=a(wt,"A",{id:!0,class:!0,href:!0});var Cs=i(H);Ue=a(Cs,"SPAN",{});var Gs=i(Ue);U(te.$$.fragment,Gs),Gs.forEach(t),Cs.forEach(t),It=c(wt),ke=a(wt,"SPAN",{});var Ts=i(ke);qt=l(Ts,"Inference"),Ts.forEach(t),wt.forEach(t),Qe=c(e),he=a(e,"P",{});var Is=i(he);xt=l(Is,`During inference, pipelines rely heavily on random sampling operations which include creating the
Gaussian noise tensors to denoise and adding noise to the scheduling step.`),Is.forEach(t),Ve=c(e),B=a(e,"P",{});var $t=i(B);At=l($t,"Take a look at the tensor values in the "),ye=a($t,"A",{href:!0});var qs=i(ye);Mt=l(qs,"DDIMPipeline"),qs.forEach(t),Nt=l($t," after two inference steps:"),$t.forEach(t),Xe=c(e),U(se.$$.fragment,e),Ze=c(e),ge=a(e,"P",{});var xs=i(ge);Ot=l(xs,"Running the code above prints one value, but if you run it again you get a different value. What is going on here?"),xs.forEach(t),et=c(e),z=a(e,"P",{});var Pt=i(z);St=l(Pt,"Every time the pipeline is run, "),ne=a(Pt,"A",{href:!0,rel:!0});var As=i(ne);Ce=a(As,"CODE",{});var Ms=i(Ce);Rt=l(Ms,"torch.randn"),Ms.forEach(t),As.forEach(t),Ft=l(Pt," uses a different random seed to create Gaussian noise which is denoised stepwise. This leads to a different result each time it is run, which is great for diffusion pipelines since it generates a different random image each time."),Pt.forEach(t),tt=c(e),ve=a(e,"P",{});var Ns=i(ve);Wt=l(Ns,"But if you need to reliably generate the same image, that\u2019ll depend on whether you\u2019re running the pipeline on a CPU or GPU."),Ns.forEach(t),st=c(e),N=a(e,"H3",{class:!0});var Et=i(N);Y=a(Et,"A",{id:!0,class:!0,href:!0});var Os=i(Y);Ge=a(Os,"SPAN",{});var Ss=i(Ge);U(re.$$.fragment,Ss),Ss.forEach(t),Os.forEach(t),Lt=c(Et),Te=a(Et,"SPAN",{});var Rs=i(Te);Ht=l(Rs,"CPU"),Rs.forEach(t),Et.forEach(t),nt=c(e),J=a(e,"P",{});var jt=i(J);Bt=l(jt,"To generate reproducible results on a CPU, you\u2019ll need to use a PyTorch "),ae=a(jt,"A",{href:!0,rel:!0});var Fs=i(ae);Ie=a(Fs,"CODE",{});var Ws=i(Ie);zt=l(Ws,"Generator"),Ws.forEach(t),Fs.forEach(t),Yt=l(jt," and set a seed:"),jt.forEach(t),rt=c(e),U(ie.$$.fragment,e),at=c(e),q=a(e,"P",{});var je=i(q);Jt=l(je,"Now when you run the code above, it always prints a value of "),qe=a(je,"CODE",{});var Ls=i(qe);Kt=l(Ls,"1491.1711"),Ls.forEach(t),Qt=l(je," no matter what because the "),xe=a(je,"CODE",{});var Hs=i(xe);Vt=l(Hs,"Generator"),Hs.forEach(t),Xt=l(je," object with the seed is passed to all the random functions of the pipeline."),je.forEach(t),it=c(e),_e=a(e,"P",{});var Bs=i(_e);Zt=l(Bs,"If you run this code example on your specific hardware and PyTorch version, you should get a similar, if not the same, result."),Bs.forEach(t),ot=c(e),U(K.$$.fragment,e),lt=c(e),O=a(e,"H3",{class:!0});var Dt=i(O);Q=a(Dt,"A",{id:!0,class:!0,href:!0});var zs=i(Q);Ae=a(zs,"SPAN",{});var Ys=i(Ae);U(oe.$$.fragment,Ys),Ys.forEach(t),zs.forEach(t),es=c(Dt),Me=a(Dt,"SPAN",{});var Js=i(Me);ts=l(Js,"GPU"),Js.forEach(t),Dt.forEach(t),pt=c(e),be=a(e,"P",{});var Ks=i(be);ss=l(Ks,"Writing a reproducible pipeline on a GPU is a bit trickier, and full reproducibility across different hardware is not guaranteed because matrix multiplication - which diffusion pipelines require a lot of - is less deterministic on a GPU than a CPU. For example, if you run the same code example above on a GPU:"),Ks.forEach(t),dt=c(e),U(le.$$.fragment,e),ut=c(e),we=a(e,"P",{});var Qs=i(we);ns=l(Qs,"The result is not the same even though you\u2019re using an identical seed because the GPU uses a different random number generator than the CPU."),Qs.forEach(t),ct=c(e),P=a(e,"P",{});var x=i(P);rs=l(x,"To circumvent this problem, \u{1F9E8} Diffusers has a "),$e=a(x,"A",{href:!0});var Vs=i($e);Ne=a(Vs,"CODE",{});var Xs=i(Ne);as=l(Xs,"randn_tensor"),Xs.forEach(t),Vs.forEach(t),is=l(x," function for creating random noise on the CPU, and then moving the tensor to a GPU if necessary. The "),Oe=a(x,"CODE",{});var Zs=i(Oe);os=l(Zs,"randn_tensor"),Zs.forEach(t),ls=l(x," function is used everywhere inside the pipeline, allowing the user to "),Se=a(x,"STRONG",{});var en=i(Se);ps=l(en,"always"),en.forEach(t),ds=l(x," pass a CPU "),Re=a(x,"CODE",{});var tn=i(Re);us=l(tn,"Generator"),tn.forEach(t),cs=l(x," even if the pipeline is run on a GPU."),x.forEach(t),ft=c(e),Pe=a(e,"P",{});var sn=i(Pe);fs=l(sn,"You\u2019ll see the results are much closer now!"),sn.forEach(t),mt=c(e),U(pe.$$.fragment,e),ht=c(e),U(V.$$.fragment,e),yt=c(e),X=a(e,"P",{});var Ut=i(X);ms=l(Ut,"Finally, for more complex pipelines such as "),Ee=a(Ut,"A",{href:!0});var nn=i(Ee);hs=l(nn,"UnCLIPPipeline"),nn.forEach(t),ys=l(Ut,`, these are often extremely
susceptible to precision error propagation. Don\u2019t expect similar results across
different GPU hardware or PyTorch versions. In this case, you\u2019ll need to run
exactly the same hardware and PyTorch version for full reproducibility.`),Ut.forEach(t),gt=c(e),S=a(e,"H2",{class:!0});var kt=i(S);Z=a(kt,"A",{id:!0,class:!0,href:!0});var rn=i(Z);Fe=a(rn,"SPAN",{});var an=i(Fe);U(de.$$.fragment,an),an.forEach(t),rn.forEach(t),gs=c(kt),We=a(kt,"SPAN",{});var on=i(We);vs=l(on,"randn_tensor"),on.forEach(t),kt.forEach(t),vt=c(e),R=a(e,"DIV",{class:!0});var Ct=i(R);U(ue.$$.fragment,Ct),_s=c(Ct),F=a(Ct,"P",{});var De=i(F);bs=l(De,"This is a helper function that allows to create random tensors on the desired "),Le=a(De,"CODE",{});var ln=i(Le);ws=l(ln,"device"),ln.forEach(t),$s=l(De," with the desired "),He=a(De,"CODE",{});var pn=i(He);Ps=l(pn,"dtype"),pn.forEach(t),Es=l(De,`. When
passing a list of generators one can seed each batched size individually. If CPU generators are passed the tensor
will always be created on CPU.`),De.forEach(t),Ct.forEach(t),this.h()},h(){f(d,"name","hf:doc:metadata"),f(d,"content",JSON.stringify(bn)),f(h,"id","create-reproducible-pipelines"),f(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(h,"href","#create-reproducible-pipelines"),f(m,"class","relative group"),f(v,"href","reusing_seeds"),f(H,"id","inference"),f(H,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(H,"href","#inference"),f(M,"class","relative group"),f(ye,"href","/docs/diffusers/main/en/api/pipelines/ddim#diffusers.DDIMPipeline"),f(ne,"href","https://pytorch.org/docs/stable/generated/torch.randn.html"),f(ne,"rel","nofollow"),f(Y,"id","cpu"),f(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(Y,"href","#cpu"),f(N,"class","relative group"),f(ae,"href","https://pytorch.org/docs/stable/generated/torch.randn.html"),f(ae,"rel","nofollow"),f(Q,"id","gpu"),f(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(Q,"href","#gpu"),f(O,"class","relative group"),f($e,"href","#diffusers.utils.randn_tensor"),f(Ee,"href","/docs/diffusers/main/en/api/pipelines/unclip#diffusers.UnCLIPPipeline"),f(Z,"id","diffusers.utils.randn_tensor"),f(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),f(Z,"href","#diffusers.utils.randn_tensor"),f(S,"class","relative group"),f(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,n){s(document.head,d),p(e,b,n),p(e,m,n),s(m,h),s(h,E),k(_,E,null),s(m,$),s(m,w),s(w,j),p(e,g,n),p(e,y,n),s(y,I),s(y,v),s(v,A),s(y,fe),p(e,ee,n),p(e,me,n),s(me,Tt),p(e,Je,n),k(L,e,n),p(e,Ke,n),p(e,M,n),s(M,H),s(H,Ue),k(te,Ue,null),s(M,It),s(M,ke),s(ke,qt),p(e,Qe,n),p(e,he,n),s(he,xt),p(e,Ve,n),p(e,B,n),s(B,At),s(B,ye),s(ye,Mt),s(B,Nt),p(e,Xe,n),k(se,e,n),p(e,Ze,n),p(e,ge,n),s(ge,Ot),p(e,et,n),p(e,z,n),s(z,St),s(z,ne),s(ne,Ce),s(Ce,Rt),s(z,Ft),p(e,tt,n),p(e,ve,n),s(ve,Wt),p(e,st,n),p(e,N,n),s(N,Y),s(Y,Ge),k(re,Ge,null),s(N,Lt),s(N,Te),s(Te,Ht),p(e,nt,n),p(e,J,n),s(J,Bt),s(J,ae),s(ae,Ie),s(Ie,zt),s(J,Yt),p(e,rt,n),k(ie,e,n),p(e,at,n),p(e,q,n),s(q,Jt),s(q,qe),s(qe,Kt),s(q,Qt),s(q,xe),s(xe,Vt),s(q,Xt),p(e,it,n),p(e,_e,n),s(_e,Zt),p(e,ot,n),k(K,e,n),p(e,lt,n),p(e,O,n),s(O,Q),s(Q,Ae),k(oe,Ae,null),s(O,es),s(O,Me),s(Me,ts),p(e,pt,n),p(e,be,n),s(be,ss),p(e,dt,n),k(le,e,n),p(e,ut,n),p(e,we,n),s(we,ns),p(e,ct,n),p(e,P,n),s(P,rs),s(P,$e),s($e,Ne),s(Ne,as),s(P,is),s(P,Oe),s(Oe,os),s(P,ls),s(P,Se),s(Se,ps),s(P,ds),s(P,Re),s(Re,us),s(P,cs),p(e,ft,n),p(e,Pe,n),s(Pe,fs),p(e,mt,n),k(pe,e,n),p(e,ht,n),k(V,e,n),p(e,yt,n),p(e,X,n),s(X,ms),s(X,Ee),s(Ee,hs),s(X,ys),p(e,gt,n),p(e,S,n),s(S,Z),s(Z,Fe),k(de,Fe,null),s(S,gs),s(S,We),s(We,vs),p(e,vt,n),p(e,R,n),k(ue,R,null),s(R,_s),s(R,F),s(F,bs),s(F,Le),s(Le,ws),s(F,$s),s(F,He),s(He,Ps),s(F,Es),_t=!0},p(e,[n]){const ce={};n&2&&(ce.$$scope={dirty:n,ctx:e}),L.$set(ce);const Be={};n&2&&(Be.$$scope={dirty:n,ctx:e}),K.$set(Be);const ze={};n&2&&(ze.$$scope={dirty:n,ctx:e}),V.$set(ze)},i(e){_t||(C(_.$$.fragment,e),C(L.$$.fragment,e),C(te.$$.fragment,e),C(se.$$.fragment,e),C(re.$$.fragment,e),C(ie.$$.fragment,e),C(K.$$.fragment,e),C(oe.$$.fragment,e),C(le.$$.fragment,e),C(pe.$$.fragment,e),C(V.$$.fragment,e),C(de.$$.fragment,e),C(ue.$$.fragment,e),_t=!0)},o(e){G(_.$$.fragment,e),G(L.$$.fragment,e),G(te.$$.fragment,e),G(se.$$.fragment,e),G(re.$$.fragment,e),G(ie.$$.fragment,e),G(K.$$.fragment,e),G(oe.$$.fragment,e),G(le.$$.fragment,e),G(pe.$$.fragment,e),G(V.$$.fragment,e),G(de.$$.fragment,e),G(ue.$$.fragment,e),_t=!1},d(e){t(d),e&&t(b),e&&t(m),T(_),e&&t(g),e&&t(y),e&&t(ee),e&&t(me),e&&t(Je),T(L,e),e&&t(Ke),e&&t(M),T(te),e&&t(Qe),e&&t(he),e&&t(Ve),e&&t(B),e&&t(Xe),T(se,e),e&&t(Ze),e&&t(ge),e&&t(et),e&&t(z),e&&t(tt),e&&t(ve),e&&t(st),e&&t(N),T(re),e&&t(nt),e&&t(J),e&&t(rt),T(ie,e),e&&t(at),e&&t(q),e&&t(it),e&&t(_e),e&&t(ot),T(K,e),e&&t(lt),e&&t(O),T(oe),e&&t(pt),e&&t(be),e&&t(dt),T(le,e),e&&t(ut),e&&t(we),e&&t(ct),e&&t(P),e&&t(ft),e&&t(Pe),e&&t(mt),T(pe,e),e&&t(ht),T(V,e),e&&t(yt),e&&t(X),e&&t(gt),e&&t(S),T(de),e&&t(vt),e&&t(R),T(ue)}}}const bn={local:"create-reproducible-pipelines",sections:[{local:"inference",sections:[{local:"cpu",title:"CPU"},{local:"gpu",title:"GPU"}],title:"Inference"},{local:"diffusers.utils.randn_tensor",title:"randn_tensor"}],title:"Create reproducible pipelines"};function wn(W){return mn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Un extends dn{constructor(d){super();un(this,d,wn,_n,cn,{})}}export{Un as default,bn as metadata};
