import{S as qt,i as Bt,s as Rt,e as n,k as d,w as Z,t as l,M as Ft,c as o,d as i,m as c,a,x as J,h as f,b as r,G as t,g as u,y as Y,L as Vt,q as j,o as K,B as Q,v as Wt}from"../../../chunks/vendor-hf-doc-builder.js";import{D as It}from"../../../chunks/Docstring-hf-doc-builder.js";import{I as He}from"../../../chunks/IconCopyLink-hf-doc-builder.js";function Zt(ut){let h,he,m,w,X,x,Oe,ee,Me,me,_,$,te,k,Ce,ie,Ge,_e,N,S,Le,Ue,ve,E,ze,H,Ie,qe,ge,P,Be,O,Re,Fe,be,v,y,ne,M,Ve,oe,We,De,A,ae,g,re,Ze,Je,se,Ye,je,I,Ke,Qe,le,b,fe,C,Xe,et,de,ce,tt,it,q,nt,we,D,T,ue,G,ot,pe,at,$e,p,L,rt,U,st,B,lt,ft,dt,R,z,Ee;return x=new He({}),k=new He({}),M=new He({}),G=new He({}),L=new It({props:{name:"class diffusers.DanceDiffusionPipeline",anchor:"diffusers.DanceDiffusionPipeline",parameters:[{name:"unet",val:""},{name:"scheduler",val:""}],parametersDescription:[{anchor:"diffusers.DanceDiffusionPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/main/en/api/models#diffusers.UNet1DModel">UNet1DModel</a>) &#x2014; U-Net architecture to denoise the encoded image.',name:"unet"},{anchor:"diffusers.DanceDiffusionPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/main/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image. Can be one of
<a href="/docs/diffusers/main/en/api/schedulers/ipndm#diffusers.IPNDMScheduler">IPNDMScheduler</a>.`,name:"scheduler"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/dance_diffusion/pipeline_dance_diffusion.py#L27"}}),z=new It({props:{name:"__call__",anchor:"diffusers.DanceDiffusionPipeline.__call__",parameters:[{name:"batch_size",val:": int = 1"},{name:"num_inference_steps",val:": int = 100"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"audio_length_in_s",val:": typing.Optional[float] = None"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.DanceDiffusionPipeline.__call__.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of audio samples to generate.`,name:"batch_size"},{anchor:"diffusers.DanceDiffusionPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality audio sample at
the expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.DanceDiffusionPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.DanceDiffusionPipeline.__call__.audio_length_in_s",description:`<strong>audio_length_in_s</strong> (<code>float</code>, <em>optional</em>, defaults to <code>self.unet.config.sample_size/self.unet.config.sample_rate</code>) &#x2014;
The length of the generated audio sample in seconds. Note that the output of the pipeline, <em>i.e.</em>
<code>sample_size</code>, will be <code>audio_length_in_s</code> * <code>self.unet.config.sample_rate</code>.`,name:"audio_length_in_s"},{anchor:"diffusers.DanceDiffusionPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.AudioPipelineOutput">AudioPipelineOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/dance_diffusion/pipeline_dance_diffusion.py#L43",returnDescription:`
<p><code>~pipelines.utils.AudioPipelineOutput</code> if <code>return_dict</code> is
True, otherwise a \`tuple. When returning a tuple, the first element is a list with the generated images.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.AudioPipelineOutput"
>AudioPipelineOutput</a> or <code>tuple</code></p>
`}}),{c(){h=n("meta"),he=d(),m=n("h1"),w=n("a"),X=n("span"),Z(x.$$.fragment),Oe=d(),ee=n("span"),Me=l("Dance Diffusion"),me=d(),_=n("h2"),$=n("a"),te=n("span"),Z(k.$$.fragment),Ce=d(),ie=n("span"),Ge=l("Overview"),_e=d(),N=n("p"),S=n("a"),Le=l("Dance Diffusion"),Ue=l(" by Zach Evans."),ve=d(),E=n("p"),ze=l(`Dance Diffusion is the first in a suite of generative audio tools for producers and musicians to be released by Harmonai.
For more info or to get involved in the development of these tools, please visit `),H=n("a"),Ie=l("https://harmonai.org"),qe=l(" and fill out the form on the front page."),ge=d(),P=n("p"),Be=l("The original codebase of this implementation can be found "),O=n("a"),Re=l("here"),Fe=l("."),be=d(),v=n("h2"),y=n("a"),ne=n("span"),Z(M.$$.fragment),Ve=d(),oe=n("span"),We=l("Available Pipelines:"),De=d(),A=n("table"),ae=n("thead"),g=n("tr"),re=n("th"),Ze=l("Pipeline"),Je=d(),se=n("th"),Ye=l("Tasks"),je=d(),I=n("th"),Ke=l("Colab"),Qe=d(),le=n("tbody"),b=n("tr"),fe=n("td"),C=n("a"),Xe=l("pipeline_dance_diffusion.py"),et=d(),de=n("td"),ce=n("em"),tt=l("Unconditional Audio Generation"),it=d(),q=n("td"),nt=l("-"),we=d(),D=n("h2"),T=n("a"),ue=n("span"),Z(G.$$.fragment),ot=d(),pe=n("span"),at=l("DanceDiffusionPipeline"),$e=d(),p=n("div"),Z(L.$$.fragment),rt=d(),U=n("p"),st=l("This model inherits from "),B=n("a"),lt=l("DiffusionPipeline"),ft=l(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),dt=d(),R=n("div"),Z(z.$$.fragment),this.h()},l(e){const s=Ft('[data-svelte="svelte-1phssyn"]',document.head);h=o(s,"META",{name:!0,content:!0}),s.forEach(i),he=c(e),m=o(e,"H1",{class:!0});var Pe=a(m);w=o(Pe,"A",{id:!0,class:!0,href:!0});var pt=a(w);X=o(pt,"SPAN",{});var ht=a(X);J(x.$$.fragment,ht),ht.forEach(i),pt.forEach(i),Oe=c(Pe),ee=o(Pe,"SPAN",{});var mt=a(ee);Me=f(mt,"Dance Diffusion"),mt.forEach(i),Pe.forEach(i),me=c(e),_=o(e,"H2",{class:!0});var ye=a(_);$=o(ye,"A",{id:!0,class:!0,href:!0});var _t=a($);te=o(_t,"SPAN",{});var vt=a(te);J(k.$$.fragment,vt),vt.forEach(i),_t.forEach(i),Ce=c(ye),ie=o(ye,"SPAN",{});var gt=a(ie);Ge=f(gt,"Overview"),gt.forEach(i),ye.forEach(i),_e=c(e),N=o(e,"P",{});var ct=a(N);S=o(ct,"A",{href:!0,rel:!0});var bt=a(S);Le=f(bt,"Dance Diffusion"),bt.forEach(i),Ue=f(ct," by Zach Evans."),ct.forEach(i),ve=c(e),E=o(e,"P",{});var Ae=a(E);ze=f(Ae,`Dance Diffusion is the first in a suite of generative audio tools for producers and musicians to be released by Harmonai.
For more info or to get involved in the development of these tools, please visit `),H=o(Ae,"A",{href:!0,rel:!0});var Dt=a(H);Ie=f(Dt,"https://harmonai.org"),Dt.forEach(i),qe=f(Ae," and fill out the form on the front page."),Ae.forEach(i),ge=c(e),P=o(e,"P",{});var Te=a(P);Be=f(Te,"The original codebase of this implementation can be found "),O=o(Te,"A",{href:!0,rel:!0});var wt=a(O);Re=f(wt,"here"),wt.forEach(i),Fe=f(Te,"."),Te.forEach(i),be=c(e),v=o(e,"H2",{class:!0});var xe=a(v);y=o(xe,"A",{id:!0,class:!0,href:!0});var $t=a(y);ne=o($t,"SPAN",{});var Et=a(ne);J(M.$$.fragment,Et),Et.forEach(i),$t.forEach(i),Ve=c(xe),oe=o(xe,"SPAN",{});var Pt=a(oe);We=f(Pt,"Available Pipelines:"),Pt.forEach(i),xe.forEach(i),De=c(e),A=o(e,"TABLE",{});var ke=a(A);ae=o(ke,"THEAD",{});var yt=a(ae);g=o(yt,"TR",{});var F=a(g);re=o(F,"TH",{});var At=a(re);Ze=f(At,"Pipeline"),At.forEach(i),Je=c(F),se=o(F,"TH",{});var Tt=a(se);Ye=f(Tt,"Tasks"),Tt.forEach(i),je=c(F),I=o(F,"TH",{align:!0});var xt=a(I);Ke=f(xt,"Colab"),xt.forEach(i),F.forEach(i),yt.forEach(i),Qe=c(ke),le=o(ke,"TBODY",{});var kt=a(le);b=o(kt,"TR",{});var V=a(b);fe=o(V,"TD",{});var Nt=a(fe);C=o(Nt,"A",{href:!0,rel:!0});var St=a(C);Xe=f(St,"pipeline_dance_diffusion.py"),St.forEach(i),Nt.forEach(i),et=c(V),de=o(V,"TD",{});var Ht=a(de);ce=o(Ht,"EM",{});var Ot=a(ce);tt=f(Ot,"Unconditional Audio Generation"),Ot.forEach(i),Ht.forEach(i),it=c(V),q=o(V,"TD",{align:!0});var Mt=a(q);nt=f(Mt,"-"),Mt.forEach(i),V.forEach(i),kt.forEach(i),ke.forEach(i),we=c(e),D=o(e,"H2",{class:!0});var Ne=a(D);T=o(Ne,"A",{id:!0,class:!0,href:!0});var Ct=a(T);ue=o(Ct,"SPAN",{});var Gt=a(ue);J(G.$$.fragment,Gt),Gt.forEach(i),Ct.forEach(i),ot=c(Ne),pe=o(Ne,"SPAN",{});var Lt=a(pe);at=f(Lt,"DanceDiffusionPipeline"),Lt.forEach(i),Ne.forEach(i),$e=c(e),p=o(e,"DIV",{class:!0});var W=a(p);J(L.$$.fragment,W),rt=c(W),U=o(W,"P",{});var Se=a(U);st=f(Se,"This model inherits from "),B=o(Se,"A",{href:!0});var Ut=a(B);lt=f(Ut,"DiffusionPipeline"),Ut.forEach(i),ft=f(Se,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Se.forEach(i),dt=c(W),R=o(W,"DIV",{class:!0});var zt=a(R);J(z.$$.fragment,zt),zt.forEach(i),W.forEach(i),this.h()},h(){r(h,"name","hf:doc:metadata"),r(h,"content",JSON.stringify(Jt)),r(w,"id","dance-diffusion"),r(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(w,"href","#dance-diffusion"),r(m,"class","relative group"),r($,"id","overview"),r($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r($,"href","#overview"),r(_,"class","relative group"),r(S,"href","https://github.com/Harmonai-org/sample-generator"),r(S,"rel","nofollow"),r(H,"href","https://harmonai.org"),r(H,"rel","nofollow"),r(O,"href","https://github.com/Harmonai-org/sample-generator"),r(O,"rel","nofollow"),r(y,"id","available-pipelines"),r(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(y,"href","#available-pipelines"),r(v,"class","relative group"),r(I,"align","center"),r(C,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/dance_diffusion/pipeline_dance_diffusion.py"),r(C,"rel","nofollow"),r(q,"align","center"),r(T,"id","diffusers.DanceDiffusionPipeline"),r(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),r(T,"href","#diffusers.DanceDiffusionPipeline"),r(D,"class","relative group"),r(B,"href","/docs/diffusers/main/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),r(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),r(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,s){t(document.head,h),u(e,he,s),u(e,m,s),t(m,w),t(w,X),Y(x,X,null),t(m,Oe),t(m,ee),t(ee,Me),u(e,me,s),u(e,_,s),t(_,$),t($,te),Y(k,te,null),t(_,Ce),t(_,ie),t(ie,Ge),u(e,_e,s),u(e,N,s),t(N,S),t(S,Le),t(N,Ue),u(e,ve,s),u(e,E,s),t(E,ze),t(E,H),t(H,Ie),t(E,qe),u(e,ge,s),u(e,P,s),t(P,Be),t(P,O),t(O,Re),t(P,Fe),u(e,be,s),u(e,v,s),t(v,y),t(y,ne),Y(M,ne,null),t(v,Ve),t(v,oe),t(oe,We),u(e,De,s),u(e,A,s),t(A,ae),t(ae,g),t(g,re),t(re,Ze),t(g,Je),t(g,se),t(se,Ye),t(g,je),t(g,I),t(I,Ke),t(A,Qe),t(A,le),t(le,b),t(b,fe),t(fe,C),t(C,Xe),t(b,et),t(b,de),t(de,ce),t(ce,tt),t(b,it),t(b,q),t(q,nt),u(e,we,s),u(e,D,s),t(D,T),t(T,ue),Y(G,ue,null),t(D,ot),t(D,pe),t(pe,at),u(e,$e,s),u(e,p,s),Y(L,p,null),t(p,rt),t(p,U),t(U,st),t(U,B),t(B,lt),t(U,ft),t(p,dt),t(p,R),Y(z,R,null),Ee=!0},p:Vt,i(e){Ee||(j(x.$$.fragment,e),j(k.$$.fragment,e),j(M.$$.fragment,e),j(G.$$.fragment,e),j(L.$$.fragment,e),j(z.$$.fragment,e),Ee=!0)},o(e){K(x.$$.fragment,e),K(k.$$.fragment,e),K(M.$$.fragment,e),K(G.$$.fragment,e),K(L.$$.fragment,e),K(z.$$.fragment,e),Ee=!1},d(e){i(h),e&&i(he),e&&i(m),Q(x),e&&i(me),e&&i(_),Q(k),e&&i(_e),e&&i(N),e&&i(ve),e&&i(E),e&&i(ge),e&&i(P),e&&i(be),e&&i(v),Q(M),e&&i(De),e&&i(A),e&&i(we),e&&i(D),Q(G),e&&i($e),e&&i(p),Q(L),Q(z)}}}const Jt={local:"dance-diffusion",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"diffusers.DanceDiffusionPipeline",title:"DanceDiffusionPipeline"}],title:"Dance Diffusion"};function Yt(ut){return Wt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Xt extends qt{constructor(h){super();Bt(this,h,Yt,Zt,Rt,{})}}export{Xt as default,Jt as metadata};
